SET FOREIGN_KEY_CHECKS=0;
DROP TABLE IF EXISTS `wst_goods`;
CREATE TABLE `wst_goods` (
  `goodsId` int(11) NOT NULL AUTO_INCREMENT,
  `goodsSn` varchar(20) NOT NULL,
  `productNo` varchar(20) NOT NULL,
  `goodsName` varchar(50) NOT NULL,
  `goodsImg` varchar(150) NOT NULL,
  `shopId` int(11) NOT NULL,
  `marketPrice` decimal(11,2) NOT NULL DEFAULT '0.00',
  `shopPrice` decimal(11,2) NOT NULL DEFAULT '0.00',
  `warnStock` int(11) NOT NULL DEFAULT '0',
  `goodsStock` int(11) NOT NULL DEFAULT '0',
  `goodsUnit` char(10) NOT NULL,
  `goodsTips` text,
  `isSale` tinyint(4) NOT NULL DEFAULT '1',
  `isBest` tinyint(4) NOT NULL DEFAULT '0',
  `isHot` tinyint(4) NOT NULL DEFAULT '0',
  `isNew` tinyint(4) NOT NULL DEFAULT '0',
  `isRecom` tinyint(4) DEFAULT '0',
  `goodsCatIdPath` varchar(255) DEFAULT NULL,
  `goodsCatId` int(11) NOT NULL,
  `shopCatId1` int(11) NOT NULL,
  `shopCatId2` int(11) NOT NULL,
  `brandId` int(11) DEFAULT '0',
  `goodsDesc` text NOT NULL,
  `goodsStatus` tinyint(4) NOT NULL DEFAULT '0',
  `saleNum` int(11) NOT NULL DEFAULT '0',
  `saleTime` datetime NOT NULL,
  `visitNum` int(11) DEFAULT '0',
  `appraiseNum` int(11) DEFAULT '0',
  `isSpec` tinyint(4) NOT NULL DEFAULT '0',
  `gallery` text,
  `goodsSeoKeywords` varchar(200) DEFAULT NULL,
  `illegalRemarks` varchar(255) DEFAULT NULL,
  `dataFlag` tinyint(4) NOT NULL DEFAULT '1',
  `createTime` datetime NOT NULL,
  PRIMARY KEY (`goodsId`),
  KEY `shopId` (`shopId`) USING BTREE,
  KEY `goodsStatus` (`goodsStatus`,`dataFlag`,`isSale`) USING BTREE,
  KEY `goodsCatIdPath` (`goodsCatIdPath`)
) ENGINE=InnoDB AUTO_INCREMENT=66 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of wst_goods
-- ----------------------------
INSERT INTO `wst_goods` VALUES ('1', '147589527734432', '147589527734432', '开源商城系统荣耀畅玩5X 双卡双待 增强全网通版', 'upload/shops/2016-10/57f8641d41b80.jpg', '1', '2999.00', '1099.00', '123', '720323', '个', '', '1', '1', '1', '1', '1', '334_348_351_', '351', '1', '4', '1', '<img src=\"/upload/image/20161008/20161008050041_27424.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008050049_53629.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008050058_22485.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008050110_19711.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008050118_90005.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008050126_78065.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008050137_40890.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008050147_48660.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008050247_54024.jpg\" alt=\"\" />', '1', '0', '2016-10-08 11:12:34', '15', '1', '1', 'upload/goods/2016-10/57f863ff76e45.jpg,upload/goods/2016-10/57f864006f452.jpg,upload/goods/2016-10/57f8640089f95.jpg', '', null, '1', '2016-10-08 11:12:34'),
('2', '147591515801959', '147591515801959', '开源商城系统 泰国金枕榴莲6.5-7斤', 'upload/shops/2016-10/57f8ae5c37486.jpg', '2', '100.00', '88.00', '12', '9985', '个', '', '1', '1', '1', '1', '1', '47_61_72_', '72', '12', '19', '0', '<p>\n	测试商品，请勿下单\n</p>\n<p>\n	<br />\n</p>\n<p>\n	<img src=\"/upload/image/20161008/20161008102747_22648.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008102755_88008.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008102804_39012.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008102815_40761.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008102825_66933.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008102834_15795.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008102843_25905.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008102853_57757.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008102902_95833.jpg\" alt=\"\" />\n</p>', '1', '0', '2016-10-08 16:29:53', '37', '1', '0', 'upload/goods/2016-10/57f8ae7dd7a86.jpg,upload/goods/2016-10/57f8ae7e1cbd1.jpg,upload/goods/2016-10/57f8ae7e33a09.jpg,upload/goods/2016-10/57f8ae7e7fec3.jpg,upload/goods/2016-10/57f8ae7f33a1c.jpg', '', null, '1', '2016-10-08 16:29:53'),
('3', '147591600797332', '147591600797332', '开源多用户系统 进口香蕉4斤', 'upload/shops/2016-10/57f8b0ff55267.jpg', '2', '42.00', '32.00', '12', '23220', '件', '', '1', '1', '1', '1', '1', '47_61_72_', '72', '12', '19', '0', '<p>\n	测试商品，请勿下单\n</p>\n<p>\n	<img src=\"/upload/image/20161008/20161008104259_28105.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008104307_48375.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008104314_13683.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008104323_10840.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008104335_87703.png\" alt=\"\" /><img src=\"/upload/image/20161008/20161008104345_38125.png\" alt=\"\" /><img src=\"/upload/image/20161008/20161008104356_49531.png\" alt=\"\" /><img src=\"/upload/image/20161008/20161008104436_93674.jpg\" alt=\"\" />\n</p>', '1', '0', '2016-10-08 16:48:03', '13', '1', '0', 'upload/goods/2016-10/57f8b14010c9f.jpg,upload/goods/2016-10/57f8b14027ad7.jpg', '', null, '1', '2016-10-08 16:44:38'),
('4', '147591677161305', '147591677161305', '开源商城系统 美国顶级青蛇果4个800g', 'upload/shops/2016-10/57f8b434e2549.jpg', '2', '46.00', '30.00', '3', '23241', '件', '', '1', '1', '1', '1', '1', '47_61_73_', '73', '12', '13', '0', '<img src=\"/upload/image/20161008/20161008105440_50025.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008105450_35051.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008105500_82960.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008105509_25943.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008105523_60635.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008105531_22604.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008105540_15718.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008105551_72704.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008105559_41506.jpg\" alt=\"\" />', '1', '0', '2016-10-08 16:56:12', '13', '0', '0', 'upload/goods/2016-10/57f8b4aa4e1b8.jpg', '', null, '1', '2016-10-08 16:56:12'),
('5', '147591741762543', '147591741762543', 'wstmart开源系统 进口柠檬4个', 'upload/shops/2016-10/57f8b7ba3343a.jpg', '2', '30.00', '20.00', '10', '23423', '件', '清新的颜色，清新的芬芳，让人精神为之一振的酸感。产自美国，长相可爱，颜色鲜黄，味道极酸，不适宜直接吃，适合做饮料和调味品，还可以美容养颜，清除冰箱气味。总之，小小个头的它拥有大大的能量哦！', '1', '1', '1', '1', '1', '47_61_72_', '72', '12', '15', '0', '<p>\n	测试商品，请勿下单\n</p>\n<p>\n	<br />\n</p>\n<p>\n	<img src=\"/upload/image/20161008/20161008110509_51833.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008110519_80584.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008110527_27138.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008110536_67021.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008110544_70375.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008110551_80133.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008110600_73665.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008110610_81600.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008110619_90095.jpg\" alt=\"\" />\n</p>', '1', '0', '2016-10-08 17:09:17', '8', '0', '0', 'upload/goods/2016-10/57f8b7a42f58a.jpg,upload/goods/2016-10/57f8b7a48ae6a.jpg,upload/goods/2016-10/57f8b7a4b10c7.jpg,upload/goods/2016-10/57f8b7ab4273f.jpg', '开源商城', null, '1', '2016-10-08 17:09:17'),
('6', '147592283198939', '147592283198939', '开源多用户系统 南非红西柚1个', 'upload/shops/2016-10/57f8cbc5de871.jpg', '2', '30.00', '20.00', '23', '32423423', '个', '', '1', '0', '1', '0', '1', '47_61_72_', '72', '12', '16', '0', '<img src=\"/upload/image/20161008/20161008123550_60438.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008123558_12298.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008123605_28704.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008123614_88604.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008123622_35070.jpg\" alt=\"\" />', '1', '0', '2016-10-08 18:36:24', '10', '0', '0', 'upload/goods/2016-10/57f8cbd9684d7.jpg,upload/goods/2016-10/57f8cbd999e4d.jpg', '', null, '1', '2016-10-08 18:36:24'),
('7', '147592353524384', '147592353524384', 'wstmart开源商城 咖喱果2斤', 'upload/shops/2016-10/57f8ce8feee6f.jpg', '2', '40.00', '30.00', '23', '234234', '件', '', '1', '0', '1', '0', '1', '47_61_72_', '72', '12', '14', '0', '<img src=\"/upload/image/20161008/20161008124648_23993.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008124657_18140.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008124706_48136.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008124715_76231.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008124736_15281.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008124745_64140.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008124754_95234.jpg\" alt=\"\" />', '1', '0', '2016-10-08 18:48:23', '2', '0', '0', 'upload/goods/2016-10/57f8cef461ea4.jpg,upload/goods/2016-10/57f8cef4880ff.jpg,upload/goods/2016-10/57f8cef537f47.jpg,upload/goods/2016-10/57f8cef5d08b3.jpg', '', null, '1', '2016-10-08 18:47:57'),
('8', '147592425246718', '147592425246718', 'WSTMART开源商城 澳洲橙8个（约4斤）', 'upload/shops/2016-10/57f8d1c8af574.jpg', '2', '60.00', '50.00', '234', '34352342', '件', '', '1', '0', '1', '0', '1', '47_61_72_', '72', '12', '15', '0', '<img src=\"/upload/image/20161008/20161008125839_70320.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008125848_40470.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008125859_71762.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008125907_27413.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008125917_40580.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008125925_27487.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008125933_50198.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008125942_88719.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008125953_91334.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008130002_37339.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008130015_28597.jpg\" alt=\"\" />', '1', '0', '2016-10-08 19:00:41', '4', '0', '0', 'upload/goods/2016-10/57f8d1d6c6404.jpg,upload/goods/2016-10/57f8d1d685669.jpg,upload/goods/2016-10/57f8d1d68d07c.jpg,upload/goods/2016-10/57f8d1d71e67a.jpg', '开源商城系统', null, '1', '2016-10-08 19:00:41'),
('9', '147593278250082', '147593278250082', 'wstmart开源商城 越南进口红心火龙果1个（约1斤）', 'upload/shops/2016-10/57f8f4aba605a.jpg', '2', '15.80', '12.80', '20', '2147483647', '件', '', '1', '1', '1', '1', '1', '47_61_77_', '77', '12', '19', '0', '<img src=\"/upload/image/20161008/20161008153008_38803.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008153018_79884.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008153026_95641.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008153037_20566.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008153056_49517.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008153107_93224.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008153115_20884.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008153126_56120.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008153136_18563.jpg\" alt=\"\" /><img src=\"/upload/image/20161008/20161008153147_80177.jpg\" alt=\"\" />', '1', '0', '2016-10-08 21:34:01', '2', '0', '0', 'upload/goods/2016-10/57f8f4d25608c.jpg,upload/goods/2016-10/57f8f4d2d3ebb.jpg,upload/goods/2016-10/57f8f4d26cec3.jpg,upload/goods/2016-10/57f8f4d60d910.jpg,upload/goods/2016-10/57f8f4d370bd9.jpg', '开源商城系统', null, '1', '2016-10-08 21:32:14'),
('10', '147598203283767', '147598203283767', '开源多用户商城 旭耕2016头茬有机荷兰青小黄瓜（当日采摘发货） 1.5kg', 'upload/shops/2016-10/57f9b3bc43e83.jpg', '3', '2342.00', '2234.00', '24', '2342', '件', '', '1', '1', '0', '0', '1', '47_62_256_', '256', '33', '0', '0', '<img src=\"/upload/image/20161009/20161009050314_93037.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009050324_26078.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009050332_53151.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009050340_57581.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009050349_83446.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009050358_66277.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009050407_88560.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009050414_95451.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009050422_21428.jpg\" alt=\"\" />', '1', '0', '2016-10-09 11:04:42', '3', '0', '0', 'upload/goods/2016-10/57f9b3c8c1d4c.jpg,upload/goods/2016-10/57f9b3c8d8b84.jpg', '开源多用户商城', null, '1', '2016-10-09 11:04:42'),
('11', '147601350646166', '147601350646166', '开源商城系统 维达超韧180g卷纸', 'upload/shops/2016-10/57fa2dd120a49.jpg', '4', '60.00', '58.00', '23', '342423422', '件', '', '1', '1', '1', '1', '1', '48_74_75_', '75', '45', '47', '2', '<img src=\"/upload/image/20161009/20161009134839_46881.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009134850_15460.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009134858_48443.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009134905_42261.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009134913_25081.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009134922_74819.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009134930_21714.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009134937_59345.jpg\" alt=\"\" />', '1', '0', '2016-10-09 20:29:57', '6', '0', '0', 'upload/goods/2016-10/57fa2e7e2ca0b.jpg,upload/goods/2016-10/57fa2e7e02aa6.jpg,upload/goods/2016-10/57fa2e7cb5f3c.jpg,upload/goods/2016-10/57fa2e7e02aa6.jpg', '', null, '1', '2016-10-09 19:49:41'),
('12', '147601599464722', '147601599464722', '开源多用户商城 维达V4006宾馆小卷纸80克双层原木浆厕所用纸卫生纸限区包邮-10提', 'upload/shops/2016-10/57fa37a377e96.jpg', '4', '180.00', '168.00', '23', '2342342', '箱', '', '1', '1', '1', '1', '1', '48_74_262_', '262', '42', '43', '0', '<img src=\"/upload/image/20161009/20161009142828_63017.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009142836_41695.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009142844_32890.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009142851_66730.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009142859_75203.jpg\" alt=\"\" />', '1', '0', '2016-10-09 20:29:05', '2', '0', '0', 'upload/goods/2016-10/57fa37b1ad56f.jpg,upload/goods/2016-10/57fa37b1d74d3.jpg,upload/goods/2016-10/57fa37b227d37.jpg,upload/goods/2016-10/57fa37b227d37.jpg', '开源多用户商城', null, '1', '2016-10-09 20:29:05'),
('13', '147601639360286', '147601639360286', '开源商城系统 维达卷纸超韧3层纸巾无芯100g*3提30卷 无香卫生纸卷筒厕家用c6', 'upload/shops/2016-10/57fa391b9ad4e.jpg', '4', '32423.00', '2342.00', '323', '234234', '件', '', '1', '1', '1', '1', '1', '48_74_262_', '262', '42', '44', '2', '<img src=\"/upload/image/20161009/20161009143455_21291.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009143503_27303.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009143512_45609.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009143519_14553.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009143527_32461.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009143534_14402.jpg\" alt=\"\" />', '1', '0', '2016-10-09 20:35:55', '3', '0', '0', '', 'php开源系统', null, '1', '2016-10-09 20:35:39'),
('14', '147601830643385', '147601830643385', 'wstmar多用户商城 香港AXE/斧头牌柠檬护肤洗洁精1.18kg*3瓶不伤手送洗碗布+钢丝球', 'upload/shops/2016-10/57fa40a79f7e9.jpg', '5', '23.00', '14.00', '12', '23234223', 'wstmar开源系统', '', '1', '1', '1', '1', '1', '48_258_267_', '267', '0', '0', '0', '<img src=\"/upload/image/20161009/20161009150642_68760.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009150652_55975.jpg\" alt=\"\" /><img src=\"/upload/image/20161009/20161009150702_44716.jpg\" alt=\"\" />', '1', '0', '2016-10-09 21:08:40', '6', '0', '0', 'upload/goods/2016-10/57fa40b2c5b19.jpg,upload/goods/2016-10/57fa40b281072.jpg,upload/goods/2016-10/57fa40b281072.jpg', '', null, '1', '2016-10-09 21:08:40'),
('15', '147601926878045', '147601926878045', 'wstmart开源商城 威露士妈妈壹选家用洗洁精 无毒天然浓缩洗碗不伤手正品包邮', 'upload/shops/2016-10/57fa445eaf658.jpg', '5', '78.00', '56.00', '23', '3435353', '件', '', '1', '1', '1', '1', '1', '48_258_267_', '267', '0', '0', '3', '<img src=\"/upload/image/20161009/20161009152238_32071.jpg\" alt=\"\" />', '1', '0', '2016-10-09 21:22:42', '4', '0', '0', 'upload/goods/2016-10/57fa446fa4083.jpg,upload/goods/2016-10/57fa446fb71b1.jpg,upload/goods/2016-10/57fa447000006.jpg,upload/goods/2016-10/57fa44709c683.jpg', '', null, '1', '2016-10-09 21:22:42'),
('16', '147601989941758', '147601989941758', 'mstmart开源商城 蓝月亮天然茶清洗洁精1kg 绿茶浓缩精华温和不伤手无残留可洗果蔬', 'upload/shops/2016-10/57fa46d2c1997.jpg', '5', '234.00', '23.00', '234', '2343442', '瓶', '', '1', '1', '1', '1', '1', '48_258_267_', '267', '0', '0', '4', '<p>\n	wstmart 蓝月亮\n</p>\n<p>\n	测试商品，请勿下单\n</p>', '1', '0', '2016-10-09 21:33:08', '2', '0', '0', 'upload/goods/2016-10/57fa46e23857b.jpg,upload/goods/2016-10/57fa46e2479a1.jpg', 'wstmart商城', null, '1', '2016-10-09 21:33:08'),
('17', '147602121726447', '147602121726447', 'wstmart 开源商城【买2减4】蓝月亮茶清天然绿茶洗洁精洗涤灵无残留果蔬清洗500g', 'upload/shops/2016-10/57fa4bf4315bd.jpg', '5', '45.00', '43.00', '342', '234342', '件', '', '1', '1', '1', '1', '1', '48_258_267_', '267', '0', '0', '4', '<p>\n	开源商城系统\n</p>\n<p>\n	请勿下单\n</p>\n<p>\n	<img src=\"/upload/image/20161009/20161009155507_72218.jpg\" alt=\"\" />\n</p>', '1', '0', '2016-10-09 21:55:10', '3', '0', '0', 'upload/goods/2016-10/57fa4c04d5716.jpg,upload/goods/2016-10/57fa4c0540abc.jpg,upload/goods/2016-10/57fa4c055b5fc.jpg,upload/goods/2016-10/57fa4c056aa21.jpg', '免费开源商城', null, '1', '2016-10-09 21:55:10'),
('18', '147602143801735', '147602143801735', 'wstmart开源商城 绿伞餐具果蔬净洗洁精2瓶家用洗碗机清洗剂餐具洗涤剂洗涤灵清洗', 'upload/shops/2016-10/57fa4ccd2e38e.jpg', '5', '23487284.00', '23422.00', '234', '321431242', '瓶', '', '1', '1', '1', '1', '1', '48_258_267_', '267', '0', '0', '4', '<p>\n	开源商城 系统\n</p>\n<p>\n	<br />\n</p>\n<p>\n	<img src=\"/upload/image/20161009/20161009155847_98796.jpg\" alt=\"\" />\n</p>', '1', '0', '2016-10-09 21:58:50', '2', '0', '0', 'upload/goods/2016-10/57fa4cddbf3b8.jpg,upload/goods/2016-10/57fa4cde8da4d.jpg,upload/goods/2016-10/57fa4cde8da4d.jpg,upload/goods/2016-10/57fa4cdee5621.jpg', 'wstmart开源商城系统', null, '1', '2016-10-09 21:58:50'),
('19', '147602173491179', '147602173491179', 'wstmart开源系统 【苏宁易购】雕牌洗洁精冷水去油1.5kg', 'upload/shops/2016-10/57fa4df4f1b23.jpg', '5', '2342.00', '233.00', '23', '234234', '瓶', '', '1', '1', '1', '1', '1', '48_258_267_', '267', '0', '0', '5', '<p>\n	这个是测试商品，请不要下单\n</p>\n<p>\n	<br />\n</p>\n<p>\n	<img src=\"/upload/image/20161009/20161009160327_11216.jpg\" alt=\"\" />\n</p>', '1', '0', '2016-10-09 22:03:29', '7', '0', '0', 'upload/goods/2016-10/57fa4dfe83198.jpg,upload/goods/2016-10/57fa4dfe9dcd9.jpg,upload/goods/2016-10/57fa4dfec022b.jpg,upload/goods/2016-10/57fa4dff0166c.jpg', 'wstmart开源系统', null, '1', '2016-10-09 22:03:29'),
('20', '147606466803599', '147606466803599', 'wstmart thinkphp商城 青岛啤酒 奥古特500ml*12听/箱 德国进口麦芽高端啤酒', 'upload/shops/2016-10/57faf6addb474.jpg', '6', '100.00', '80.00', '2', '12312313', '箱', '', '1', '1', '1', '1', '1', '49_78_296_', '296', '55', '60', '6', '<img src=\"/upload/image/20161010/20161010040301_46024.jpg\" alt=\"\" />', '1', '0', '2016-10-10 10:03:36', '2', '0', '0', 'upload/goods/2016-10/57faf6f5375ba.jpg,upload/goods/2016-10/57faf6f5375ba.jpg,upload/goods/2016-10/57faf6f5c8513.jpg,upload/goods/2016-10/57faf6f659b12.jpg', 'wstmart thinkphp 5.0商城', null, '1', '2016-10-10 10:03:36'),
('21', '147606513405564', '147606513405564', 'tp 5.0开源商城 青岛啤酒 黑啤 500ml *12听/箱高端焦香麦芽 PK德国黑啤进口啤酒', 'upload/shops/2016-10/57faf7843b656.jpg', '6', '67.00', '64.00', '23', '2342342', '箱', '', '1', '1', '1', '1', '1', '49_78_296_', '296', '55', '62', '6', '<img src=\"/upload/image/20161010/20161010040800_60759.jpg\" alt=\"\" /><img src=\"/upload/image/20161010/20161010040807_74044.jpg\" alt=\"\" />', '1', '0', '2016-10-10 10:08:11', '2', '0', '0', 'upload/goods/2016-10/57faf7c746f1e.jpg,upload/goods/2016-10/57faf7c7a6501.jpg', 'tp 5.0开源商城', null, '1', '2016-10-10 10:08:11'),
('22', '147606545349522', '147606545349522', 'thinkphp多用户商城 青岛啤酒纯生500ml*12听/箱 德国进口麦芽啤酒 全国包邮', 'upload/shops/2016-10/57faf8b91d5c7.jpg', '6', '76.00', '56.00', '23', '234234', '箱', '', '1', '1', '1', '1', '1', '49_78_296_', '296', '55', '60', '6', '<img src=\"/upload/image/20161010/20161010041527_16698.jpg\" alt=\"\" />', '1', '0', '2016-10-10 10:15:30', '2', '0', '0', 'upload/goods/2016-10/57faf8be0e1c2.jpg,upload/goods/2016-10/57faf8be69a9d.jpg,upload/goods/2016-10/57faf8be8bfef.jpg', 'thinkphp多用户商城', null, '1', '2016-10-10 10:15:30'),
('23', '147606603490527', '147606603490527', '开源多用户商城 青岛啤酒 纯生330ml*24听/箱 德国进口麦芽啤酒 全国包邮', 'upload/shops/2016-10/57fafd4bd27b2.jpg', '6', '168.00', '150.00', '23', '234242', '箱', '', '1', '1', '1', '1', '1', '49_78_296_', '296', '55', '60', '6', '<p>\n	<img src=\"/upload/image/20161010/20161010043122_26866.jpg\" alt=\"\" />\n</p>\n<p>\n	<br />\n</p>', '1', '0', '2016-10-10 10:39:33', '2', '0', '0', 'upload/goods/2016-10/57fafd52a0e69.jpg,upload/goods/2016-10/57fafd52cead6.jpg,upload/goods/2016-10/57fafd52ed31f.jpg,upload/goods/2016-10/57fafd531f33a.jpg', '开源多用户商城', null, '1', '2016-10-10 10:31:25'),
('24', '147606726064746', '147606726064746', 'php开源商城 青岛啤酒 福禄寿禧系列 禧罐500ml*12听装 婚庆喜宴 全国包邮', 'upload/shops/2016-10/57faffd3b8ca6.jpg', '6', '100.00', '80.00', '23', '23422', '箱', '', '1', '1', '1', '1', '1', '49_78_296_', '296', '55', '60', '6', '<img src=\"/upload/image/20161010/20161010044212_19827.jpg\" alt=\"\" />', '1', '0', '2016-10-10 10:42:15', '2', '0', '0', 'upload/goods/2016-10/57faffd951cd7.jpg,upload/goods/2016-10/57faffd974228.jpg,upload/goods/2016-10/57faffd98364d.jpg', 'php开源商城', null, '1', '2016-10-10 10:42:15'),
('25', '147606743677359', '147606743677359', 'tp5.0商城 青岛啤酒 鸿运当头啤酒473ml*8瓶高端喜庆礼盒新春送礼啤酒', 'upload/shops/2016-10/57fb0076520c3.jpg', '6', '80.00', '60.00', '32', '50000', '箱', '', '1', '1', '1', '1', '1', '49_78_296_', '296', '55', '61', '0', '<img src=\"/upload/image/20161010/20161010044509_28363.jpg\" alt=\"\" />', '1', '0', '2016-10-10 10:45:24', '2', '0', '0', 'upload/goods/2016-10/57fb00c40d813.jpg,upload/goods/2016-10/57fb00c41cc37.jpg,upload/goods/2016-10/57fb00c42c05c.jpg', 'tp5.0商城', null, '1', '2016-10-10 10:45:24'),
('26', '147606824468491', '147606824468491', 'wstmart金龙鱼阳光葵花籽油5L*4大桶装 粮油葵花油植物油金龙鱼油整箱油', 'upload/shops/2016-10/57fb096855a03.jpg', '7', '268.00', '234.00', '2', '23232', '箱', '', '1', '1', '1', '1', '1', '50_220_242_', '242', '63', '69', '0', '<img src=\"/upload/image/20161010/20161010052312_39503.jpg\" alt=\"\" />', '1', '0', '2016-10-10 11:23:14', '2', '0', '0', 'upload/goods/2016-10/57fb096d7bc7e.jpg,upload/goods/2016-10/57fb096e334d8.jpg,upload/goods/2016-10/57fb096e3ebf3.jpg', '', null, '1', '2016-10-10 11:23:14'),
('27', '147608254602411', '147608254602411', 'wstmart 开源商城 三只松鼠 猪肉脯210g休闲零食小吃靖江特产猪肉干', 'upload/shops/2016-10/57fb3b80adbef.jpg', '8', '35.00', '32.00', '23', '2322323', '千克', '', '1', '1', '1', '1', '1', '52_190_205_', '205', '75', '89', '0', '<img src=\"/upload/image/20161010/20161010085735_76533.jpg\" alt=\"\" />', '1', '0', '2016-10-10 14:57:38', '2', '0', '0', 'upload/goods/2016-10/57fb3b9ff2759.jpg,upload/goods/2016-10/57fb3ba0378a2.jpg,upload/goods/2016-10/57fb3ba0378a2.jpg', 'wstmart 开源商城', null, '1', '2016-10-10 14:57:38'),
('28', '147608304088668', '147608304088668', '开源商城系统 三只松鼠 小贱牛肉粒110g零食特产小吃牛肉干XO酱味', 'upload/shops/2016-10/57fb3d6b30a09.jpg', '8', '46.00', '34.00', '32', '2423423', '千克', '', '1', '1', '1', '1', '1', '52_190_205_', '205', '75', '0', '0', '<img src=\"/upload/image/20161010/20161010090504_85879.jpg\" alt=\"\" />', '1', '0', '2016-10-10 15:05:19', '2', '0', '0', 'upload/goods/2016-10/57fb3dad3c2cb.jpg,upload/goods/2016-10/57fb3dad3c2cb.jpg,upload/goods/2016-10/57fb3dad6dc41.jpg', '开源商城系统', null, '1', '2016-10-10 15:05:19'),
('29', '147608334434175', '147608334434175', '开源商城系统 三只松鼠 小贱牛板筋120g零食特产小吃牛肉干麻辣味', 'upload/shops/2016-10/57fb3e9975c3a.jpg', '8', '67.00', '45.00', '234', '23432', '千克', '', '1', '1', '1', '1', '1', '52_190_205_', '205', '75', '88', '0', '<img src=\"/upload/image/20161010/20161010091003_51025.jpg\" alt=\"\" />', '1', '0', '2016-10-10 15:10:05', '2', '0', '0', 'upload/goods/2016-10/57fb3eb531249.jpg,upload/goods/2016-10/57fb3eb54bd89.jpg,upload/goods/2016-10/57fb3eb562bbf.jpg', '', null, '1', '2016-10-10 15:10:05'),
('30', '147608352554609', '147608352554609', 'tp5 开源商城系统 三只松鼠 约辣辣条200g 麻辣零食面制素食辣片诱惑辣', 'upload/shops/2016-10/57fb3f58baba4.jpg', '8', '67.00', '34.00', '23', '2342342', '千克', '', '1', '1', '1', '1', '1', '52_190_205_', '205', '75', '87', '0', '<img src=\"/upload/image/20161010/20161010091320_53088.jpg\" alt=\"\" />', '1', '0', '2016-10-10 15:13:26', '3', '0', '0', 'upload/goods/2016-10/57fb3f63dd13c.jpg,upload/goods/2016-10/57fb3f63ec560.jpg,upload/goods/2016-10/57fb3f6403a3c.jpg', 'tp5 开源商城系统', null, '1', '2016-10-10 15:13:26'),
('31', '147608391176727', '147608391176727', 'PHP开源商城 三只松鼠 草莓干106g 休闲食品零食食品果脯草莓脯', 'upload/shops/2016-10/57fb40d84cb35.jpg', '8', '89.00', '45.00', '34', '4234243', '千克', '', '1', '1', '1', '1', '1', '52_190_204_', '204', '74', '80', '0', '<img src=\"/upload/image/20161010/20161010091937_97835.jpg\" alt=\"\" />', '1', '0', '2016-10-10 15:19:39', '2', '0', '0', '', 'PHP开源商城', null, '1', '2016-10-10 15:19:39'),
('32', '147608399104898', '147608399104898', 'thinkphp开源商城 三只松鼠 红香妃葡萄干280g零食蜜饯新疆红葡萄干', 'upload/shops/2016-10/57fb4188bf6ad.jpg', '8', '343.00', '232.00', '12', '23323', '千克', '', '1', '1', '1', '1', '1', '52_192_216_', '216', '76', '0', '0', '<img src=\"/upload/image/20161010/20161010092247_85879.jpg\" alt=\"\" />', '1', '0', '2016-10-10 15:22:49', '2', '0', '0', 'upload/goods/2016-10/57fb418f50cd2.jpg,upload/goods/2016-10/57fb418f73224.jpg,upload/goods/2016-10/57fb418f9947f.jpg', 'thinkphp开源商城', null, '1', '2016-10-10 15:22:49'),
('33', '147608714349100', '147608714349100', 'PHP开源商城 Sisley希思黎焕白化妆水200ml 植物调理露爽肤水保湿滋润', 'upload/shops/2016-10/57fb4e0ddb503.jpg', '9', '300.00', '230.00', '20', '30000', '支', '', '1', '1', '1', '1', '1', '51_165_172_', '172', '93', '0', '7', '<img src=\"/upload/image/20161010/20161010101549_30437.jpg\" alt=\"\" />', '1', '0', '2016-10-10 16:15:55', '2', '0', '0', 'upload/goods/2016-10/57fb4e15bccee.jpg,upload/goods/2016-10/57fb4e15d782e.jpg,upload/goods/2016-10/57fb4e15f236d.jpg,upload/goods/2016-10/57fb4e163b1bf.jpg', 'PHP开源商城', null, '1', '2016-10-10 16:15:55'),
('34', '147608767224440', '147608767224440', 'php开源系统 正品 Sisley希思黎全日呵护精华乳/液50ml 紧致补水保湿', 'upload/shops/2016-10/57fb4f8565a50.jpg', '9', '300.00', '200.00', '2', '29090', '支', '', '1', '1', '1', '1', '1', '51_165_172_', '172', '93', '0', '7', '<img src=\"/upload/image/20161010/20161010102239_94715.jpg\" alt=\"\" />', '1', '0', '2016-10-10 16:22:41', '2', '0', '0', 'upload/goods/2016-10/57fb4f8db1f39.jpg,upload/goods/2016-10/57fb4f8dc8d70.jpg,upload/goods/2016-10/57fb4f8e1d2dc.jpg,upload/goods/2016-10/57fb4f8e43537.jpg', 'php开源系统', null, '1', '2016-10-10 16:22:41'),
('35', '147608796876190', '147608796876190', '开源商城系统 Sisley/希思黎Sisley/希思黎滋润化妆水柔肤保湿喷雾125ml 保湿', 'upload/shops/2016-10/57fb50adef6fe.jpg', '9', '900.00', '800.00', '23', '20000', '支', '', '1', '1', '1', '1', '1', '51_165_172_', '172', '93', '0', '7', '<img src=\"/upload/image/20161010/20161010102739_38223.jpg\" alt=\"\" />', '1', '0', '2016-10-10 16:27:42', '2', '0', '0', 'upload/goods/2016-10/57fb50b2e4002.jpg', '开源商城系统', null, '1', '2016-10-10 16:27:42'),
('36', '147608814182550', '147608814182550', 'wstmart 希思黎 亮彩修护疗程 4x5ml', 'upload/shops/2016-10/57fb515a84e52.jpg', '9', '300.00', '200.00', '20', '3000', '支', '', '1', '1', '1', '1', '1', '51_165_172_', '172', '93', '0', '7', '<img src=\"/upload/image/20161010/20161010103039_42904.jpg\" alt=\"\" />', '1', '0', '2016-10-10 16:30:49', '2', '0', '0', '', 'wstmart', null, '1', '2016-10-10 16:30:49'),
('37', '147608851390609', '147608851390609', '多用户商城系统正品 Sisley希思黎经典修护眼唇霜30ml 眼啫喱 淡眼袋黑眼圈补水', 'upload/shops/2016-10/57fb52d4af729.jpg', '9', '400.00', '340.00', '20', '40000', '盒', '', '1', '1', '1', '1', '1', '51_165_172_', '172', '93', '0', '7', '<img src=\"/upload/image/20161010/20161010103644_11518.jpg\" alt=\"\" />', '1', '0', '2016-10-10 16:36:47', '2', '0', '0', 'upload/goods/2016-10/57fb52de29f2b.jpg,upload/goods/2016-10/57fb52de44a6b.jpg,upload/goods/2016-10/57fb52de50186.jpg,upload/goods/2016-10/57fb52dea404e.jpg', '多用户商城系统', null, '1', '2016-10-10 16:36:47'),
('38', '147608894026815', '147608894026815', 'wstmart 香港直发！Sisley希思黎至臻夜间修护眼部精华露15ml 小金瓶眼霜', 'upload/shops/2016-10/57fb54760fe1e.jpg', '9', '700.00', '500.00', '20', '50000', '支', '', '1', '1', '1', '1', '1', '51_165_172_', '172', '93', '0', '7', '<img src=\"/upload/image/20161010/20161010104325_41440.jpg\" alt=\"\" />', '1', '0', '2016-10-10 16:43:27', '2', '0', '0', 'upload/goods/2016-10/57fb547d9d09c.jpg,upload/goods/2016-10/57fb547dbb8e5.jpg,upload/goods/2016-10/57fb547e00a2d.jpg,upload/goods/2016-10/57fb547e50bec.jpg', 'wstmart 开源商城系统', null, '1', '2016-10-10 16:43:27'),
('39', '147608921059806', '147608921059806', 'wstmart开源商城 鲁花5S一级花生油4L 物理压榨 食用油 健康纯正', 'upload/shops/2016-10/57fb5e34d7904.jpg', '7', '300.00', '200.00', '20', '376676', '瓶', '', '1', '1', '1', '1', '1', '50_220_245_', '245', '63', '68', '9', '<img src=\"/upload/image/20161010/20161010112501_90172.jpg\" alt=\"\" />', '1', '0', '2016-10-10 17:25:18', '2', '0', '0', 'upload/goods/2016-10/57fb5e7d97654.jpg', 'wstmart开源商城', null, '1', '2016-10-10 17:25:18'),
('40', '147609157348168', '147609157348168', 'wstmart 鲁花5S一级花生油3.68L 物理压榨食用油 健康', 'upload/shops/2016-10/57fb5ec0535b4.jpg', '7', '199.00', '189.00', '10', '10000', '瓶', '', '1', '1', '1', '1', '1', '50_220_245_', '245', '63', '68', '9', '<img src=\"/upload/image/20161010/20161010112712_19917.jpg\" alt=\"\" />', '1', '0', '2016-10-10 17:27:15', '2', '0', '0', 'upload/goods/2016-10/57fb5ec67d604.jpg,upload/goods/2016-10/57fb5ec6c9ac4.jpg', '', null, '1', '2016-10-10 17:27:15'),
('41', '147609173705043', '147609173705043', 'wstmart 福临门 花生原香调和油 5L/桶 健康家居食用油', 'upload/shops/2016-10/57fb5f867f2d1.jpg', '7', '299.00', '200.00', '20', '2000', '只', '', '1', '1', '1', '1', '1', '50_220_242_', '242', '63', '66', '8', '<img src=\"/upload/image/20161010/20161010113342_18009.jpg\" alt=\"\" />', '1', '0', '2016-10-10 17:33:53', '2', '0', '0', 'upload/goods/2016-10/57fb5f92ad111.jpg', 'wstmart开源系统', null, '1', '2016-10-10 17:33:53'),
('42', '147609213139370', '147609213139370', 'wstmart开源商城 福临门AE非转基因压榨浓香菜籽油 4L/桶 健康食用油', 'upload/shops/2016-10/57fb60f80c627.jpg', '7', '500.00', '300.00', '90', '2090', '瓶', '', '1', '1', '1', '1', '1', '50_220_242_', '242', '63', '69', '8', '<img src=\"/upload/image/20161010/20161010113704_95924.jpg\" alt=\"\" />', '1', '0', '2016-10-10 17:37:07', '2', '0', '0', '', 'wstmart开源商城', null, '1', '2016-10-10 17:37:07'),
('43', '147609291231430', '147609291231430', 'wstmart开源商城 金龙鱼 葵花食用调和油5L+花生浓香食用调和油5L', 'upload/shops/2016-10/57fb64067ab77.jpg', '7', '200.00', '180.00', '20', '20000', '件', '', '1', '1', '1', '1', '1', '50_220_242_', '242', '63', '69', '10', '<img src=\"/upload/image/20161010/20161010114957_90307.jpg\" alt=\"\" />', '1', '0', '2016-10-10 17:49:59', '2', '0', '0', 'upload/goods/2016-10/57fb640eda29a.jpg', 'wstmart开源商城', null, '1', '2016-10-10 17:49:59'),
('44', '147615768009681', '147615768009681', 'WSTMart开源商城 红阿胶蜜枣1000g无核山东特产大红枣 红枣子 小包装零食食品', 'upload/shops/2016-10/57fc6106c39d6.jpg', '10', '30.00', '26.00', '23', '232232', '包', '', '1', '1', '1', '1', '1', '53_138_151_', '151', '103', '108', '0', '<img src=\"/upload/image/20161011/20161011054939_30223.jpg\" alt=\"\" />', '1', '0', '2016-10-11 11:49:40', '3', '0', '0', 'upload/goods/2016-10/57fc610c7395f.jpg,upload/goods/2016-10/57fc610c7395f.jpg,upload/goods/2016-10/57fc610cb09fe.jpg', '开源商城系统', null, '1', '2016-10-11 11:49:40'),
('45', '147615789210904', '147615789210904', '开源商城系统 阿胶糕即食女士型2盒装1000g阿胶块片手工阿胶固元膏 阿胶膏', 'upload/shops/2016-10/57fc61ccc6662.jpg', '10', '200.00', '190.00', '100', '10000', '盒', '', '1', '1', '1', '1', '1', '53_138_147_', '147', '103', '108', '0', '<img src=\"/upload/image/20161011/20161011055226_20409.jpg\" alt=\"\" />', '1', '0', '2016-10-11 11:52:28', '1', '0', '0', 'upload/goods/2016-10/57fc61d194e02.jpg,upload/goods/2016-10/57fc61d26ebd8.jpg,upload/goods/2016-10/57fc61d422785.jpg,upload/goods/2016-10/57fc61d3d1f13.jpg,upload/goods/2016-10/57fc61d46352e.jpg', '开源商城系统', null, '1', '2016-10-11 11:52:28'),
('46', '147615806640031', '147615806640031', '免费商户系统 静心R助眠口服液 15ml/支*80支', 'upload/shops/2016-10/57fc628f19a7b.jpg', '10', '400.00', '340.00', '30', '30000', '盒', '', '1', '1', '1', '1', '1', '53_139_152_', '152', '103', '109', '0', '<img src=\"/upload/image/20161011/20161011055554_98486.jpg\" alt=\"\" />', '1', '0', '2016-10-11 11:55:56', '2', '0', '0', 'upload/goods/2016-10/57fc629388580.jpg,upload/goods/2016-10/57fc6293d4a46.jpg', '免费商户系统', null, '1', '2016-10-11 11:55:56'),
('47', '147615826752131', '147615826752131', 'B2B2C商城系统 太太美容口服液 10ml/支*30支', 'upload/shops/2016-10/57fc634c3ad51.jpg', '10', '400.00', '300.00', '20', '30000', '盒', '', '1', '1', '1', '1', '1', '53_138_148_', '148', '103', '108', '0', '<img src=\"/upload/image/20161011/20161011055843_50918.jpg\" alt=\"\" />', '1', '0', '2016-10-11 11:58:47', '2', '0', '0', 'upload/goods/2016-10/57fc635168ae7.jpg,upload/goods/2016-10/57fc6351b12a3.jpg', 'B2B2C商城系统', null, '1', '2016-10-11 11:58:47'),
('48', '147615850729935', '147615850729935', 'B2B2C开源系统 红桃K 生血剂二合一(片剂+口服液) 10ml/支*10+0.45g*10*套餐', 'upload/shops/2016-10/57fc6439009fc.jpg', '10', '300.00', '238.00', '90', '10000', '件', '', '1', '1', '1', '1', '1', '53_139_153_', '153', '103', '109', '0', '<img src=\"/upload/image/20161011/20161011060251_46513.jpg\" alt=\"\" />', '1', '0', '2016-10-11 12:02:53', '2', '0', '0', 'upload/goods/2016-10/57fc643d491c2.jpg,upload/goods/2016-10/57fc643d8dc66.jpg,upload/goods/2016-10/57fc643dbf5dc.jpg', 'B2B2C开源系统', null, '1', '2016-10-11 12:02:53'),
('49', '147615879820754', '147615879820754', '开源多商家系统 健长乐牌长乐胶囊 0.35g/粒*60粒/瓶', 'upload/shops/2016-10/57fc65567382d.jpg', '10', '500.00', '400.00', '20', '30000', '盒', '', '1', '1', '1', '1', '1', '53_137_142_', '142', '103', '108', '0', '<img src=\"/upload/image/20161011/20161011060730_77733.jpg\" alt=\"\" />', '1', '0', '2016-10-11 12:07:33', '2', '0', '0', 'upload/goods/2016-10/57fc655bc3a0c.jpg,upload/goods/2016-10/57fc655bed970.jpg,upload/goods/2016-10/57fc655c2edaf.jpg,upload/goods/2016-10/57fc655c498ef.jpg', '开源多商家系统', null, '1', '2016-10-11 12:07:33'),
('50', '147616746393900', '147616746393900', 'wstmart开源商城 华为honor/荣耀 V8全网通标准版智能手机官方正品', 'upload/goods/2016-10/57fc8734005e0.jpg', '11', '2999.00', '1999.00', '10', '1878921', '个', '', '1', '1', '1', '1', '1', '334_348_351_', '351', '111', '115', '11', '<img src=\"/upload/image/20161011/20161011085117_31552.jpg\" alt=\"\" /><img src=\"/upload/image/20161011/20161011085124_32027.jpg\" alt=\"\" /><img src=\"/upload/image/20161011/20161011085133_31788.jpg\" alt=\"\" /><img src=\"/upload/image/20161011/20161011085140_94336.jpg\" alt=\"\" />', '1', '0', '2016-10-11 14:52:05', '5', '0', '1', 'upload/goods/2016-10/57fc87bb31f55.jpg,upload/goods/2016-10/57fc87bb45082.jpg,upload/goods/2016-10/57fc87bb6b2dc.jpg,upload/goods/2016-10/57fc87bc9523f.jpg', '开源商城', null, '1', '2016-10-11 14:52:05'),
('51', '147616924742345', '147616924742345', '开源商城系统 有增强版 送膜套+耳机 honor/荣耀 畅玩4C移动 电信 双4G 八核', 'upload/goods/2016-10/57fc8e279cc51.jpg', '11', '799.00', '899.00', '10', '3154835', '个', '', '1', '1', '1', '1', '1', '334_348_351_', '351', '111', '115', '11', '<img src=\"/upload/image/20161011/20161011091709_98777.jpg\" alt=\"\" /><img src=\"/upload/image/20161011/20161011091723_75214.jpg\" alt=\"\" />', '1', '0', '2016-10-11 15:18:53', '2', '0', '1', 'upload/goods/2016-10/57fc91b77e409.jpg,upload/goods/2016-10/57fc91b7bb499.jpg,upload/goods/2016-10/57fc91b7c2eab.jpg,upload/goods/2016-10/57fc91b8b7790.jpg', '开源商城系统', null, '1', '2016-10-11 15:18:53'),
('52', '147617084423590', '147617084423590', '开源商城 honor/荣耀 荣耀 NOTE 8 4G智能手机 官方正品 大屏', 'upload/goods/2016-10/57fc946a2683a.jpg', '11', '2599.00', '2699.00', '100', '328553', '个', '', '1', '1', '1', '1', '1', '334_348_351_', '351', '111', '115', '11', '<img src=\"/upload/image/20161011/20161011092923_62001.jpg\" alt=\"\" /><img src=\"/upload/image/20161011/20161011092933_68738.jpg\" alt=\"\" /><img src=\"/upload/image/20161011/20161011092947_53014.jpg\" alt=\"\" />', '1', '0', '2016-10-11 15:32:24', '3', '0', '1', 'upload/goods/2016-10/57fc94714ca94.jpg,upload/goods/2016-10/57fc9471769f7.jpg,upload/goods/2016-10/57fc947198f48.jpg,upload/goods/2016-10/57fc94729523f.jpg', '开源商城', null, '1', '2016-10-11 15:32:24'),
('53', '147617150373595', '147617150373595', '商淘软件 华为honor/荣耀 畅玩5A 长续航4G智能手机华为正品', 'upload/goods/2016-10/57fc96fdf0b17.jpg', '11', '799.00', '799.00', '90', '274200', '个', '', '1', '1', '1', '1', '1', '334_348_351_', '351', '111', '115', '11', '<img src=\"/upload/image/20161011/20161011093932_92224.jpg\" alt=\"\" /><img src=\"/upload/image/20161011/20161011093939_83712.jpg\" alt=\"\" /><img src=\"/upload/image/20161011/20161011093946_15160.jpg\" alt=\"\" /><img src=\"/upload/image/20161011/20161011093953_67843.jpg\" alt=\"\" /><img src=\"/upload/image/20161011/20161011093959_88170.jpg\" alt=\"\" />', '1', '0', '2016-10-11 15:47:30', '13', '0', '1', 'upload/goods/2016-10/57fc97046efe5.jpg,upload/goods/2016-10/57fc97047a700.jpg,upload/goods/2016-10/57fc97048d82d.jpg,upload/goods/2016-10/57fc97053d670.jpg', '商淘软件', null, '1', '2016-10-11 15:47:30'),
('54', '147617224839219', '147617224839219', '商淘软件 【直降200】华为honor/荣耀 荣耀7移动增强版32G智能手机', 'upload/goods/2016-10/57fc99e2e53fc.jpg', '11', '1599.00', '1399.00', '101', '30002', '个', '直降200元', '1', '1', '1', '1', '1', '334_348_351_', '351', '111', '115', '11', '<img src=\"/upload/image/20161011/20161011095243_68249.jpg\" alt=\"\" /><img src=\"/upload/image/20161011/20161011095250_59353.jpg\" alt=\"\" /><img src=\"/upload/image/20161011/20161011095259_53508.jpg\" alt=\"\" /><img src=\"/upload/image/20161011/20161011095317_10763.jpg\" alt=\"\" />', '1', '0', '2016-10-11 16:01:41', '2', '0', '1', 'upload/goods/2016-10/57fc99e989b24.jpg,upload/goods/2016-10/57fc99e8d5fd8.jpg,upload/goods/2016-10/57fc99e9b3a87.jpg,upload/goods/2016-10/57fc99eaac075.jpg', '商淘软件', null, '1', '2016-10-11 16:01:41'),
('55', '147667034432491', '147667034432491', 'wstmart开源商城系统 陕西特级红富士1kg (果径约80mm) 苹果 新鲜水果', 'upload/goods/2016-10/5804338fbdff6.jpg', '1', '30.00', '19.90', '12', '1000', '千克', '开源商城系统', '1', '1', '1', '1', '1', '47_61_73_', '73', '3', '123', '0', '<img src=\"/upload/image/2016-10/580433c88cc2f.jpg\" alt=\"\" />', '1', '0', '2016-10-17 10:13:42', '2', '0', '0', 'upload/goods/2016-10/580433d4a78a4.jpg,upload/goods/2016-10/580433d4d5515.jpg,upload/goods/2016-10/580433d590a85.jpg', '开源商城系统', null, '1', '2016-10-17 10:13:42'),
('56', '147667042335823', '147667042335823', 'wstmart开源多用户商城 福建平和红心蜜柚1个约1.1kg/个 柚子 新鲜水果', 'upload/goods/2016-10/580436293ca47.jpg', '1', '39.00', '32.00', '20', '20909', '个', '', '1', '0', '0', '1', '1', '47_61_72_', '72', '3', '123', '0', '<img src=\"/upload/image/2016-10/5804365aa3f2b.jpg\" alt=\"\" />', '1', '0', '2016-10-17 10:24:28', '4', '0', '0', 'upload/goods/2016-10/58043630ec2aa.jpg,upload/goods/2016-10/5804363135101.jpg,upload/goods/2016-10/58043632074aa.jpg,upload/goods/2016-10/58043632c2376.jpg', 'wstmart开源多用户商城', null, '1', '2016-10-17 10:24:28'),
('57', '147667106864032', '147667106864032', '【wstmart超市】陕西大荔冬枣(冰糖枣)500g 10-20g/个 枣子甜枣 水果', 'upload/goods/2016-10/580440d1821f7.jpg', '1', '50.00', '40.00', '90', '99990', '个', '', '1', '1', '1', '1', '1', '47_61_73_', '73', '3', '123', '0', '<img src=\"/upload/image/2016-10/580440febf3a8.jpg\" alt=\"\" />', '1', '0', '2016-10-17 11:09:53', '1', '0', '0', 'upload/goods/2016-10/580440dac2fcb.jpg,upload/goods/2016-10/580440db0440a.jpg,upload/goods/2016-10/580440daddb0b.jpg,upload/goods/2016-10/580440db2695c.jpg,upload/goods/2016-10/580440dbe181a.jpg', '开源商城系统', null, '1', '2016-10-17 11:09:53'),
('58', '147667379326775', '147667379326775', '【wstmart超市】辽宁菇娘果500g 灯笼果 新鲜水果', 'upload/goods/2016-10/58044184bf702.jpg', '1', '50.00', '40.00', '90', '99898', '斤', '', '1', '1', '1', '1', '1', '47_61_72_', '72', '3', '123', '0', '<img src=\"/upload/image/2016-10/580441bfbf87c.jpg\" alt=\"\" />', '1', '0', '2016-10-17 11:13:08', '1', '0', '0', 'upload/goods/2016-10/5804418a0486a.jpg,upload/goods/2016-10/5804418b361e7.jpg,upload/goods/2016-10/5804418bceb53.jpg,upload/goods/2016-10/5804418c0c289.jpg', 'wstmart开源系统', null, '1', '2016-10-17 11:13:08'),
('59', '147667398884708', '147667398884708', '【wstmart超市】新疆无籽青提1kg 葡萄 提子 新鲜水果', 'upload/goods/2016-10/5804423ed2cd6.jpg', '1', '50.00', '40.00', '20', '934893', '千克', '', '1', '1', '1', '1', '1', '47_61_249_', '249', '3', '123', '0', '<img src=\"/upload/image/2016-10/5804427ab0904.jpg\" alt=\"\" />', '1', '0', '2016-10-17 11:16:13', '1', '0', '0', 'upload/goods/2016-10/58044244c75e1.jpg,upload/goods/2016-10/580442460c730.jpg,upload/goods/2016-10/580442458e25f.jpg,upload/goods/2016-10/58044246605f8.jpg', 'wstmart开源系统', null, '1', '2016-10-17 11:16:13'),
('60', '147667417372324', '147667417372324', '【wstmart超市】南非柠檬4个约90g/个 进口新鲜水果', 'upload/goods/2016-10/5804435292622.jpg', '1', '20.00', '15.00', '324', '324789324', '千克', '', '1', '1', '1', '1', '1', '47_61_72_', '72', '3', '123', '0', '<img src=\"/upload/image/2016-10/5804438264ae8.jpg\" alt=\"\" />', '1', '0', '2016-10-17 11:20:36', '1', '0', '0', 'upload/goods/2016-10/5804435a2f368.jpg,upload/goods/2016-10/5804435a6c3fa.jpg,upload/goods/2016-10/5804435a92655.jpg,upload/goods/2016-10/5804435b1ff4a.jpg', '开源多用户系统', null, '1', '2016-10-17 11:20:36'),
('61', '147667443714681', '147667443714681', '【wstmart超市】新疆库尔勒精选香梨500g约120g/个', 'upload/goods/2016-10/5804445b74479.jpg', '1', '50.00', '35.00', '23', '34242', '千克', '', '1', '1', '1', '1', '1', '47_61_76_', '76', '3', '123', '0', '<img src=\"/upload/image/2016-10/580444a28b476.jpg\" alt=\"\" />', '1', '0', '2016-10-17 11:25:23', '3', '0', '0', 'upload/goods/2016-10/580444605d662.jpg,upload/goods/2016-10/58044460875c6.jpg,upload/goods/2016-10/58044460c094f.jpg,upload/goods/2016-10/58044460c094f.jpg', '免费商城系统', null, '1', '2016-10-17 11:25:23'),
('62', '147667472424247', '147667472424247', '【wstmart超市】泰国红毛丹1kg 毛荔枝 进口新鲜水果', 'upload/goods/2016-10/5804453811713.jpg', '1', '50.00', '43.00', '32', '23423242', '千克', '', '1', '1', '1', '1', '1', '47_61_72_', '72', '3', '123', '0', '<img src=\"/upload/image/2016-10/58044561693ea.jpg\" alt=\"\" />', '1', '0', '2016-10-17 11:28:40', '1', '0', '0', 'upload/goods/2016-10/5804453d2c272.jpg,upload/goods/2016-10/5804453d1ce4e.jpg,upload/goods/2016-10/5804453e9326e.jpg,upload/goods/2016-10/5804453f93275.jpg', 'wstmart开源系统', null, '1', '2016-10-17 11:28:40'),
('63', '147667492091559', '147667492091559', '【wstmart超市】台湾红宝石葡萄柚2个约280g/个 柚子 新鲜水果', 'upload/goods/2016-10/580445efa2b00.jpg', '1', '35.00', '25.00', '23', '238792934', '千克', '', '1', '1', '1', '1', '1', '47_61_72_', '72', '3', '123', '0', '<img src=\"/upload/image/2016-10/5804462074fcc.jpg\" alt=\"\" />', '1', '0', '2016-10-17 11:31:46', '1', '0', '0', 'upload/goods/2016-10/580445f53411e.jpg,upload/goods/2016-10/580445f5711b0.jpg,upload/goods/2016-10/580445f60a1c0.jpg,upload/goods/2016-10/580445f66d4ad.jpg', '开源多用户商城', null, '1', '2016-10-17 11:31:46'),
('64', '147667510624483', '147667510624483', '【wstmart超市】南非夏橙12个约190g/个 进口新鲜水果 脐橙 橙子', 'upload/goods/2016-10/5804489b75fac.jpg', '1', '79.00', '68.00', '32', '34792', '千克', '', '1', '1', '1', '1', '1', '47_61_72_', '72', '3', '123', '0', '<img src=\"/upload/image/2016-10/58044aa639c2e.jpg\" alt=\"\" />', '0', '0', '2016-10-17 11:56:59', '0', '0', '0', 'upload/goods/2016-10/580448a3a7955.jpg,upload/goods/2016-10/580448a42211d.jpg,upload/goods/2016-10/580448a412cf9.jpg,upload/goods/2016-10/580448a50b2ed.jpg', '', null, '1', '2016-10-17 11:51:04'),
('65', '147667626553350', '147667626553350', '【wstmart超市】美国红提2kg 提子 进口新鲜水果', 'upload/goods/2016-10/58044b41a1003.jpg', '1', '45.00', '32.00', '23', '234234', '千克', 'wstmart开源商城', '1', '1', '1', '1', '1', '47_61_249_', '249', '3', '123', '0', '<img src=\"/upload/image/2016-10/58044b6ebf96c.jpg\" alt=\"\" />', '1', '0', '2016-10-17 11:54:24', '1', '0', '0', 'upload/goods/2016-10/58044b483a03a.jpg,upload/goods/2016-10/58044b46ed4d9.jpg,upload/goods/2016-10/58044b4963fa5.jpg,upload/goods/2016-10/58044b4954b80.jpg', '', null, '1', '2016-10-17 11:54:24');
